# vim: ts=4
###
#
# Listen is the legal property of mehdi abaakouk <theli48@gmail.com>
# Copyright (c) 2006 Mehdi Abaakouk
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License version 2 as
# published by the Free Software Foundation
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#
###

import gtk
import gobject
import gtkhtml2
import urllib
from xml.dom import minidom
#import xml.sax.saxutils


import re
import traceback
import pango
import gnomevfs
import threading

try: import sexy
except: has_sexy = False
else: has_sexy = True

import config
import const
import stock
import utils
import random

from widget.misc import ScrolledWindow
from web_threading import WebFetchThread

from song import sType
from helper import helper

from lastfm import lastfm_info

import widget.mozembed_wrap
from widget.mozembed_wrap import MozClient


LEOLYRICS_AUTH = "listen"
WIKI_HOTE = "%s.wikipedia.org"

WIKI_URL = WIKI_HOTE+"/wiki/"
#Hum seem better
WIKI_URL = WIKI_HOTE+"/wiki/Special:Search/"

def get_template():
    font = "Sans"
    size = "11"
    full_font = config.get("setting","web_font")
    try : font = full_font [:full_font.rindex(" ")]
    except:pass
    try : size = full_font [full_font.rindex(" ")+1:]
    except:pass
    
    color_text = config.get("setting","web_color_text")
    color_link = config.get("setting","web_color_link")
    color_bg = config.get("setting","web_color_bg")
    return """
        <html>
            <head>
                <meta http-equiv="Content-Type" content="text/html; charset=utf-8">
                <style>*{
                         font-size:11px;
                         color:%s
                         background-color:%s
                        }
                        a{color:%s}
                        /*a:hover{color:blue}*/
                       body{
                         margin:0px;
                         padding:7px;
                         font-family: "%s";
                         font-size:%spx;
                         background-color:white;
                        }
                        p,ul,li,form,blockquote,dt,dd,a,b,i,u,div,span,h1,h2,h3,h4,h5,h6{
                           font-family: "%s";
                           font-size:%spx;
                        }
                        h1{font-size:1.6em;font-weight:bold;}
                        h2{font-size:1.4em;font-weight:bold;}
                        h3{font-size:1.2em;}
                        h4{font-size:1.1em;}
                        h5{font-size:1.0em;}
                        h6{font-size:0.8em;}
                        img{border:0px;}
                </style>
                </head>
            <body>
            %s
            </body>
        </html>
                """%(color_text,color_bg,color_link,font,size,font,size,"%s")
#
            #<img style="float:right;margin-top:30px;margin-right:10px;" src="file://%sbg_listen.png">                
class WikiBox(gtk.VBox):
    def __init__(self,player):
        gtk.VBox.__init__(self,False,6)
        player.connect("new-song",self.new_media_cb)

        self.last_action = "artist"
        self.song = None

        
        self.embed = MozClient()
        self.embed.connect("open-uri",self.link_uri_cb)

        self.btn_forward = self.make_btn(gtk.STOCK_GO_FORWARD,"forward")
        utils.set_tip(self.btn_forward,_("Forward"))
        self.btn_back = self.make_btn(gtk.STOCK_GO_BACK,"back")
        utils.set_tip(self.btn_back,_("Back"))
        self.btn_artist = self.make_btn(stock.WIKI_USERS,"artist",_("Artist"))
        self.btn_artist.set_active(True)
        self.btn_album = self.make_btn(stock.WIKI_CD,"album",_("Album"),self.btn_artist)
        self.btn_title = self.make_btn(gtk.STOCK_DIALOG_INFO,"title",_("Song")+"   ",self.btn_artist)

        self.btn_browser = gtk.Button()
        self.btn_browser.add(gtk.image_new_from_icon_name("stock_internet", gtk.ICON_SIZE_LARGE_TOOLBAR))
        self.btn_browser.connect("clicked",self.open_in_browser)
        utils.set_tip(self.btn_browser,_("See in web browser"))

        model = gtk.ListStore(gobject.TYPE_STRING)

        self.dropdown_lang = gtk.combo_box_new_text()
        langs = ["en","fr","de","es","it","nl","sv","pl","pt"]
        for lang in langs:
            if lang == config.get("setting","wikipedia"):
                active = langs.index(lang)
                self.lang=lang
            self.dropdown_lang.append_text(lang)

        self.dropdown_lang.set_active(active)
        self.dropdown_lang.connect("changed",self.on_change_lang)
        utils.set_tip(self.dropdown_lang,_("Change wikipedia language"))


        hbox = gtk.HBox(False,6)

        hbox.pack_start(self.btn_artist,False,False)
        hbox.pack_start(self.btn_album,False,False)
        hbox.pack_start(self.btn_title,True,True)
        hbox.pack_start(self.btn_browser,False,False)
        hbox.pack_start(self.btn_back,False,False)
        hbox.pack_start(self.btn_forward,False,False)
        hbox.pack_start(self.dropdown_lang,False,False)

        self.pack_start(hbox,False,False)
        #self.pack_start(ScrolledWindow(self.view))
        f = gtk.Frame()
        f.add(self.embed)
        self.pack_start(f)
        self.embed.show_all()
        self.site_cache={}
        
        self.current_url = None
        self.go_back_url = []
        self.go_forward_url = []
        
        self.update_btn_status()
        
        helper.connect("show-wikipedia",self.helper_cb)
        
        self.download_thread = WebFetchThread(1024,self.fail_fetch)
        #self.download_thread.dbg = True

    def fail_fetch(self):
        HTML = get_template()%("<h3>"+_("Failed to retreive data")+"</h3>")
        self.render_data(HTML)
        
    def link_uri_cb(self,w,uri):
        if uri.find("wikipedia.org")!=-1 or uri.find("wikimedia.org")!=-1:
            if self.current_url:
                self.go_back_url.append(self.current_url)
            self.go_forward_url = []
            self.download_uri(uri)
        else:
            utils.website(uri);
        return True
        
    def download_uri(self,uri):
        print "D:WikiBox:open",uri
        self.download_thread.fetch_url(uri,self.render_data,True)
        self.current_url = uri
        
        
    def render_data(self,html,prepare_data=False):
        if not isinstance(html,str) and not isinstance(html,unicode):
            html = html.read()
        if prepare_data:
            html = self.prepare_html(html)
        self.embed.set_data(self.current_url,html)
        gobject.idle_add(self.update_btn_status)
            
        
    def open_in_browser(self,btn=None):
        if self.current_url:
            utils.website(self.current_url);


    def on_change_lang(self,widget):
        self.lang = self.dropdown_lang.get_active_text()
        config.set("setting","wikipedia",self.lang)
        self.fetch_information(None,self.last_action)
        
    def helper_cb(self,helper,action,song):
        self.set_action(action)
        self.new_media_cb(None,song)
        
    def set_action(self,action):
        #FIXME: replace by block/unblock signal
        if action=="artist":
            self.btn_artist.connect("clicked",lambda x: None)
            self.btn_artist.clicked()
            self.btn_artist.connect("clicked",self.fetch_information,action)
        if action=="album":
            self.btn_album.connect("clicked",lambda x: None)
            self.btn_album.clicked()
            self.btn_album.connect("clicked",self.fetch_information,action)
        if action=="title":
            self.btn_title.connect("clicked",lambda x: None)
            self.btn_title.clicked()
            self.btn_title.connect("clicked",self.fetch_information,action)


    def make_btn(self,stocks,action,label=None,btn=None):
        if label==None:
           btn = gtk.Button()
           image = gtk.image_new_from_stock(stocks, gtk.ICON_SIZE_BUTTON)
           btn.add(image)
        else:
           btn = gtk.RadioButton(group=btn)
           image = gtk.image_new_from_stock(stocks, gtk.ICON_SIZE_BUTTON)
           label = gtk.Label(label)
           label.set_alignment(0,0.5)
           box = gtk.HBox(False,6)
           box.pack_start(image,False,False)
           box.pack_start(label,True,True)
           btn.add(box)

        btn.connect("clicked",self.fetch_information,action)
        return btn

    def new_media_cb(self,widget,song):
        if song==None or config.get("source", "wikipedia")!="1" :
            return
        print "Update Wikipedia"
        self.song = song
        if song.get_type() not in sType.wikipedia:
            HTML = get_template()%("<h3>"+_("Wikipedia not available for this media type")+"</h3>")
            self.render_data(HTML)
        else:
            self.fetch_information(None,self.last_action)

    def update_btn_status(self):
        if len(self.go_back_url)!=0:
            self.btn_back.set_sensitive(True)
        else:
            self.btn_back.set_sensitive(False)
        if len(self.go_forward_url)!=0:
            self.btn_forward.set_sensitive(True)
        else:
            self.btn_forward.set_sensitive(False)

    def fetch_information(self,btn,action):

        if action in ["artist","album","title"]:
            self.last_action=action
            if self.song==None:
                return
            url = "http://"+(WIKI_URL%self.lang)+urllib.quote(utils.filter_info_song(self.song.get_str(action)).encode("utf-8"))
            if str(url) == str(self.current_url):
                return
            if self.current_url:
                self.go_back_url.append(self.current_url)
            self.go_forward_url = []
            
            self.download_uri(url)

        elif action=="back":
            url = self.go_back_url.pop()
            if self.current_url:
                self.go_forward_url.append(self.current_url)
            self.download_uri(url)

        elif action=="forward":
            url = self.go_forward_url.pop()
            if self.current_url:
                self.go_back_url.append(self.current_url)
            self.download_uri(url)
            
        while len(self.go_back_url)>const.WIKIPEDIA_HISTORY_LEN:
            self.go_back_url.pop(0)
        while len(self.go_forward_url)>const.WIKIPEDIA_HISTORY_LEN:
            self.go_forward_url.pop(0)
        self.update_btn_status()

        
        

    def prepare_html(self,html):
            
        html = html[html.find("<body"):html.find("</body>")]
        #html = re.sub('<(.*)>', "", html)
        html = re.sub("class=\"(.[^>]*)\"","",html)
        html = re.sub("id=\"(.[^>]*)\"","",html)
        html = re.sub("style=\"(.[^>]*)\"","",html)
        #html = re.sub("<input(.[^>]*)>","",html)
        #print html

        html = get_template()%html
        return html

class LyricsBox(gtk.VBox):
    def __init__(self,player):
        gtk.VBox.__init__(self,False,6)
        self.song = None
        
        
        self.embed = MozClient()
        self.embed.connect("open-uri",self.link_uri_cb)
        
        self.text = gtk.TextView(gtk.TextBuffer())
        self.text.set_editable(False)
        padding = 5
        self.text.set_property("pixels-above-lines",padding)
        self.text.set_property("pixels-below-lines",padding)
        self.text.set_property("right_margin",padding)
        self.text.set_property("left_margin",padding)
        
        self.auto_update = gtk.CheckButton("Auto-updating")
        self.auto_update.set_property("active",True)
        
        
        self.entry_artist = gtk.Entry()
        self.entry_title = gtk.Entry()
        
        self.entry_artist.connect("activate",self.on_search_changed)
        self.entry_title.connect("activate",self.on_search_changed)
        
        
        self.entry_artist.set_sensitive(False)
        self.entry_title.set_sensitive(False)
        
        
        model = gtk.ListStore(gobject.TYPE_STRING)
        self.dropdown_server = gtk.combo_box_new_text()
        servers = ["lyrc.com.ar","leoslyrics.com"]
        for server in servers:
            if server == config.get("lyrics","server"):
                active = servers.index(server)
                self.server=server
            self.dropdown_server.append_text(server)
        
        self.dropdown_server.set_active(active)
        self.dropdown_server.connect("changed",self.on_change_lyrics_server)
        utils.set_tip(self.dropdown_server,_("Change Lyrics Server"))
        
        self.box_search = gtk.HBox(False,6)
        """self.box_search.pack_start(gtk.Label(_("Artist")),False,False)
        self.box_search.pack_start(self.entry_artist,True,True)
        self.box_search.pack_start(gtk.Label(_("Title")),False,False)
        self.box_search.pack_start(self.entry_title,True,True)"""
        l = gtk.Label(_("Lyrics server"))
        l.set_alignment(0,0.5)
        self.box_search.pack_start(l,False,False)
        self.box_search.pack_start(self.dropdown_server,False,False)
        self.box_search.pack_end(self.auto_update,False,False)
        
        self.pack_start(self.box_search,False,False)
        f = gtk.Frame()
        f.add(self.embed)
        self.pack_start(f,True,True)

        helper.connect("show-lyrics",self.new_media_cb)
        player.connect("new-song",self.new_media_cb)
        
        self.download_thread = WebFetchThread(1024,self.fail_fetch)
        
        self.is_realize = False   
        self.current_html = None
          
    def on_change_lyrics_server(self,*arg):
        self.server = self.dropdown_server.get_active_text()
        config.set("lyrics","server",self.server)
        self.on_search_changed(True)
        
    def fail_fetch(self):
        self.render_data(get_template()%(_("Server did not respond.")))
        
    def set_text(self,text):
        buffer = self.text.get_buffer()
        buffer.set_text(text)
        
    def link_uri_cb(self,w,uri):
        return True
    
    def new_media_cb(self,widget,song):
        if config.get("source", "lyrics")!="1": return 
        if not self.auto_update.get_property("active"): return 
        
        print "Update Lyrics"
        if not song or song.get_type() not in sType.lyrics:
            self.songs = None
            self.entry_artist.set_sensitive(False)
            self.entry_title.set_sensitive(False)
            self.render_data(get_template()%(""+_("Lyrics not available for this media type")+""))
        else:
            self.song = song    
            self.entry_artist.set_sensitive(True)
            self.entry_title.set_sensitive(True)
            self.entry_artist.set_text(self.song.get_str("artist"))
            self.entry_title.set_text(self.song.get_str("title"))
            self.on_search_changed()
    
        
    def on_search_changed(self,w=None):
        if not self.song: return
        if w==None and gnomevfs.exists(self.song.lyric_uri):
            text = gnomevfs.read_entire_file(self.song.lyric_uri)
            self.render_data(text.replace("\n","<br />"),False,True)
        else:
            self.render_data(get_template()%(_("Fetching lyrics for")+" \""+self.entry_artist.get_text()+ " - " +self.entry_title.get_text()+"\"<br />"+_("From")+" \""+self.server+"\"..."))
            
            artist = utils.filter_info_song(self.entry_artist.get_text())
            title = utils.filter_info_song(self.entry_title.get_text())
            
            if config.get("lyrics","server")=="leoslyrics.com":
                url = "http://api.leoslyrics.com/api_search.php?auth=%s&artist=%s&songtitle=%s"%(
                    LEOLYRICS_AUTH,
                    urllib.quote(artist.encode('utf-8')),
                    urllib.quote(title.encode('utf-8')))
                self.download_thread.fetch_url(url,self.fetch_lyrics_leolyrics,self.song)

                
            elif config.get("lyrics","server")=="lyrc.com.ar":
                url = "http://lyrc.com.ar/en/tema1en.php?artist=%s&songname=%s"%(
                    urllib.quote(artist.encode('utf-8')),
                    urllib.quote(title.encode('utf-8')))
                self.download_thread.fetch_url(url,self.fetch_lyrics_lyrccomar,self.song)
            
    def render_data(self,html,song_save=False,prepare_data=False):
        if prepare_data:
            html = html.replace("\n","")
            html = html.replace("\r","")
            if html.find("<body")!=-1:
                html = html[html.find("<body"):html.find("</body>")]
            html = re.sub("class=\"(.[^>]*)\"","",html)
            html = re.sub("id=\"(.[^>]*)\"","",html)
            html = re.sub("style=\"(.[^>]*)\"","",html)
            html = re.sub("<script.*?>.*?</script>","",html,re.S)
            html = re.sub("<center.*?>.*?</center>","",html,re.S)
            html = re.sub("<font.*?>.*?</font>","",html,re.S)
            html = html.replace("<br />","\n")
            html = re.sub('<(.*)>', "", html)
            
        if song_save and len(html)>0:
            if gnomevfs.exists(song_save.lyric_uri):
                gnomevfs.unlink(song_save.lyric_uri)
            print song_save.lyric_uri
            try:
                perm = gnomevfs.PERM_USER_ALL|gnomevfs.PERM_GROUP_ALL|gnomevfs.PERM_OTHER_ALL
                utils.makedirs(song_save.lyric_uri[:song_save.lyric_uri.rfind("/")],perm)
            except:pass
            try:
                f = gnomevfs.create(song_save.lyric_uri,gnomevfs.OPEN_WRITE)
            except:pass
            else:
                f.write(html)
                f.close()
            
        if prepare_data:
            html = html.replace("\n","<br />")    
            #Scrappy way to detect latin-1 string
            title = "<h2>"+self.song.get_str("title",True)+ " - <i>" + self.song.get_str("artist",True)+'</i></h2>'
            try:html = html.encode( "utf-8" )
            except:
                for codec in ['iso-8859-1','iso-8559-15','utf-8']:
                    try: html = html.decode(codec)
                    except (UnicodeError, LookupError): pass
                    else:
                        html = title+html
                        break
            else:
                html = title+html
            html = get_template()%html
            
        self.embed.set_data("file://",html)

    def fetch_lyrics_lyrccomar(self,html_buffer,song):
        self.render_data(html_buffer.read(),song,True)
           
        
    def fetch_lyrics_leolyrics(self,html_buffer,song):
        # Leolyrics API reader grab on lyrics.py from quodlibet Copyright 2005 Eduardo Gonzalez, Joe Wreschnig
        self.songlist = []

        try:
            xml = minidom.parse(html_buffer)
        except Exception, e:
            print "W:LyricsBox:Failed fetch_lyrics_part1 xml (traceback):"
            print traceback.format_exc()
            gobject.idle_add(self.render_data,get_template()%(_("Server did not respond.")))
            return
        
        xmldoc = xml.documentElement
        result_code = xmldoc.getElementsByTagName('response')[0].getAttribute('code')
        #print "Result code: ", result_code
        if result_code == '0': #success
            # This is 0 even if there are no matches.

            # We don't really need the top 100 matches, so I'm limiting it to ten
            matches = xmldoc.getElementsByTagName('result')[:10]
            songs = map(lambda x:
                        x.getElementsByTagName('name')[0].firstChild.nodeValue
                        + " - " +
                        x.getElementsByTagName('title')[0].firstChild.nodeValue,
                        matches)
            hids = map(lambda x: x.getAttribute('hid'), matches)
            exacts = map(lambda x: x.getAttribute('exactMatch'), matches)
            #print "->>"
            #print hids
            #print exacts
            if len(hids) == 0:
                #FIXME show other matches
                gobject.idle_add(self.render_data,get_template()%(_("Unable to find any matches for this song.")))
                return

            for i in range(len(hids)):
                self.songlist.append((songs[i], hids[i], exacts[i]))

            xmldoc.unlink()
            
            url =  "http://api.leoslyrics.com/api_lyrics.php?auth=%s&hid=%s"%(
                    LEOLYRICS_AUTH,
                    urllib.quote(self.songlist[0][1].encode('utf-8')))
                    
            self.download_thread.fetch_url(url,self.fetch_lyrics_leolyrics_part2,song)
        else:
            gobject.idle_add(self.render_data,get_template()%(_("Unable to find any matches for this song.")))


    def fetch_lyrics_leolyrics_part2(self,html_buffer,song):
        try:
            xml = minidom.parse(html_buffer)
        except Exception, e:
            print "W:LyricsBox:Failed fetch_lyrics_part1 xml (traceback):"
            print traceback.format_exc()
            self.render_data(_("Server did not respond."))
            return
        
        xmldoc = xml.documentElement
        """
        text = "<h1>"+self.decode(xmldoc.getElementsByTagName('title')[0].firstChild.nodeValue)
        text += ' - ' + self.decode(xmldoc.getElementsByTagName('artist')[0].getElementsByTagName('name')[0].firstChild.nodeValue) +"</h1>"
        text += "<p>&nbsp;</p><p>"+self.decode(xmldoc.getElementsByTagName('text')[0].firstChild.nodeValue).replace("\n","</p><p>")+"</p>"
        """
        text = xmldoc.getElementsByTagName('text')[0].firstChild.nodeValue
        
        self.render_data(text.replace("\n","<br />"),song)
        xmldoc.unlink()
            

class LastFmBox(gtk.VBox):
    def __init__(self,player):
        gtk.VBox.__init__(self,False,6)

        self.song = None
        player.connect("new-song",self.new_media_cb)
        
        btn_album = gtk.Button()
        btn_album.set_relief(gtk.RELIEF_NONE)
        btn_album.connect("clicked",self.lastfm_hook,"album")
        l = gtk.Label()
        l.set_markup("<span color=\"blue\"><u>"+_("About album")+"</u></span>")
        btn_album.add(l)
        utils.set_tip(btn_album,_("See album information at www.last.fm"))
        
        btn_artist = gtk.Button()
        btn_artist.set_relief(gtk.RELIEF_NONE)
        btn_artist.connect("clicked",self.lastfm_hook,"artist")
        l = gtk.Label()
        l.set_markup("<span color=\"blue\"><u>"+_("About artist")+"</u></span>")
        btn_artist.add(l)
        utils.set_tip(btn_artist,_("See artist information at www.last.fm"))
        
        
        
        logo = gtk.Image()
        logo.set_from_file(const.PIXMAP_DIR+"lastfm.png")
        logo.set_alignment(1,0.5)
        
        label_box = gtk.HBox(False,6)        
        label = gtk.Label()
        label.set_use_markup(True)
        label.set_markup("<span size=\"large\"><b>"+_("Similar artists")+"</b></span>")
        label.set_alignment(0,0.5)
        label.set_size_request(-1,22)        
        label_box.pack_start(label,True,True)
        
        label = gtk.Label()
        label.set_use_markup(True)
        label.set_markup("<span size=\"large\"><b>"+_("Top albums")+"</b></span>")
        label.set_alignment(0,0.5)
        label.set_size_request(-1,22)
        label_box.pack_start(label,True,True)



        self.artists_box = gtk.VBox()
        self.artists_box.pack_start(self.get_label_error(),True,True)
        
        self.albums_box = gtk.VBox()
        self.albums_box.pack_start(self.get_label_error(),True,True)

        info_box = gtk.HBox(True,6)
        info_box.pack_start(self.artists_box)
        info_box.pack_start(self.albums_box)

        self.btn_more_artist = gtk.Button()
        btn_label = gtk.Label()
        btn_label.set_markup("<span color=\"blue\"><u>"+_("More similar artists")+"</u></span>")
        btn_label.set_alignment(0,0.5)
        self.btn_more_artist.add(btn_label)
        self.btn_more_artist.connect("clicked",lambda widget:utils.website("http://www.last.fm/music/%s/+similar"%utils.filter_info_song(self.song.get_str("artist")).encode("utf-8")))
        self.btn_more_artist.set_relief(gtk.RELIEF_NONE)
        
        self.btn_more_album = gtk.Button()
        btn_label = gtk.Label()
        btn_label.set_markup("<span color=\"blue\"><u>"+_("All top albums")+"</u></span>")
        btn_label.set_alignment(0,0.5)
        self.btn_more_album.add(btn_label)
        self.btn_more_album.connect("clicked",lambda widget:utils.website("http://www.last.fm/music/%s/+topalbum"%utils.filter_info_song(self.song.get_str("artist")).encode("utf-8")))
        self.btn_more_album.set_relief(gtk.RELIEF_NONE)


       
        
        bottom_box = gtk.HBox()
        bottom_box.pack_start(btn_artist,False,False)
        bottom_box.pack_start(btn_album,False,False)
        bottom_box.pack_end(logo,False,False)

        self.pack_start(label_box,False,False)
        self.pack_start(ScrolledWindow(info_box,True,gtk.SHADOW_NONE),True,True)
        self.pack_end(bottom_box,False,False)

        self.last_artist=None
        
        self.update = False
        self.current_info ={"artist":None,"album":None}
        
        self.condition = threading.Condition()
        t = threading.Thread(target=self.thread,args=("artist",))
        t.setDaemon(True)
        t.start()
        t = threading.Thread(target=self.thread,args=("album",))
        t.setDaemon(True)
        t.start()
        
        
    def get_label_wait(self):        
        l = gtk.Label(_("Fetching informations"))
        l.set_alignment(0,0)
        return l
        
    def get_label_error(self):     
        l = gtk.Label(_("No information available"))
        l.set_alignment(0,0)
        return l
    
    def lastfm_hook(self,widget,type):
        if self.song:
            import urllib
            def prepare(str):
                return urllib.quote(utils.filter_info_song(str).encode("utf-8"))
            url = "http://www.last.fm/music/"
            if type=="artist":
                utils.website(url+prepare(self.song.get_str("artist")))
            if type=="album" and self.song.get("album"):
                utils.website(url+prepare(self.song.get_str("artist"))+"/"+prepare(self.song.get_str("album")))
            
    def new_media_cb(self,widget,song):
        if config.get("source", "lastfm")!="1": return
        if song==None:
            return
        print "Update LastFM"
        if song.get_type() not in sType.lastfm:
           self.fail_fetch()
        else:
            self.condition.acquire()
            self.current_info["artist"] = None
            self.current_info["album"] = None
            self.condition.release()
            
            if self.last_artist == song.get_str("artist"): return 

            self.last_artist = song.get_str("artist")
            self.song = song
            self.artists_box.foreach(self.artists_box.remove)
            self.albums_box.foreach(self.albums_box.remove)
            self.artists_box.pack_start(self.get_label_wait(), True,True)
            self.albums_box.pack_start(self.get_label_wait(), True,True)
            self.artists_box.show_all()
            self.albums_box.show_all()
            
            lastfm_info.get_related(self.last_artist,self.fetch_info,"artist",func_fail=self.fail,func_fail_args=("artist",))
            lastfm_info.get_topalbum(self.last_artist,self.fetch_info,"album",func_fail=self.fail,func_fail_args=("album",))

    def fail_fetch(self,*args):
        self.fail("artist")
        self.fail("album")
        
    def fail(self,type):
        print "Failed webinfo",type
        if type=="artist":
            self.artists_box.foreach(self.artists_box.remove)
            self.artists_box.pack_start(self.get_label_error(),True,True)
            self.artists_box.show_all()
        else:          
            self.albums_box.foreach(self.albums_box.remove)      
            self.albums_box.pack_start(self.get_label_error(),True,True)
            self.albums_box.show_all()
        
    def fetch_info(self,items,type):
        self.condition.acquire()    
        self.current_info[type] = items
        self.condition.notify()
        self.condition.release()
   
    def thread(self,type):
        while True:
            
            self.condition.acquire()
            while not self.current_info[type] :
                self.condition.wait()
            
            items = self.current_info[type] 
            self.current_info[type] = None            
            self.condition.release()
            
            NB_RESULT = 16
            list_btn = []
            if type=="artist":
                 for item in items[:NB_RESULT]:
                    list_btn.append(self.make_btn_lastfm(item["name"],item["url"],item["match"],_("Score")+" : "+item["match"],item["image_small"]))
                 if len(items)>NB_RESULT: list_btn.append(self.btn_more_artist)            
            else:
                 for item in items[:NB_RESULT]:    
                    list_btn.append(self.make_btn_lastfm(item["name"],item["url"],item["reach_percent"],_("Reach")+" : "+item["reach"],item["image_small"]))
                 if len(items)>NB_RESULT: list_btn.append(self.btn_more_album)
                 
            if self.current_info[type]==None:
                gobject.idle_add(self.fill_table,list_btn,type)    

        
    def fill_table(self,widgets,type):
        cols = {"artist":0,"album":1}
        col = cols[type]
        if type=="artist":
            self.artists_box.foreach(self.artists_box.remove)
        else:          
            self.albums_box.foreach(self.albums_box.remove)  
        for i,w in enumerate(widgets):
            if type=="artist":
                self.artists_box.pack_start(w,False,False)
            else:          
                self.albums_box.pack_start(w,False,False)
        if type=="artist":
            self.artists_box.show_all()
        else:          
            self.albums_box.show_all()
        
    def make_btn_lastfm(self,name,url,match,match_text,image_url):
        #print name,url,match
        btn = gtk.Button()
        btn.set_relief(gtk.RELIEF_NONE)
        progress = gtk.ProgressBar()
        progress.set_ellipsize(pango.ELLIPSIZE_END)
        frac = float(match)/float(100)
        #print frac
        progress.set_fraction(frac)
        progress.set_text(match_text)
        #progress.set_text_alignment( 0.1, 0.5 )

        l = gtk.Label()
        l.set_markup(utils.xmlescape(name))
        l.set_alignment(0,0.5)
        l.set_ellipsize(pango.ELLIPSIZE_END)
        pbox = gtk.VBox(False,0)
        pbox.pack_start(l)
        pbox.pack_start(progress,False,False)



        image = gtk.Image()
        sock = urllib.urlopen(image_url)
        loader = gtk.gdk.PixbufLoader()
        loader.set_size(40, 40)
        loader.connect("closed", lambda loader,image : image.set_from_pixbuf(loader.get_pixbuf()) ,image)
        
        def thread():
            def write(data):
                loader.write(data)
                try:loader.close()
                except gobject.GError:
                    print "W:Webinfo:Incorrect image format"
                    pass
            data = sock.read()
            sock.close()
            gobject.idle_add(write,data)
            
        t = threading.Thread(target=thread)
        t.setDaemon(True)
        t.start()

        box = gtk.HBox(False,6)
        box.pack_start(image,False,False)
        box.pack_start(pbox,True,True)
        btn.add(box)
        btn.connect("clicked",utils.url_hook,url)
        return btn


